Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -653,592 +907,286 @@
 	async_wait_for(req, &rc);
 	
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-	
-	return 0;
-}
-
-/** Get file status.
- *
- * @param path Path to file
- * @param stat Place to store file information
- *
- * @return 0 on success, -1 on error and sets errno.
- */
-int stat(const char *path, struct stat *stat)
-{
-	sysarg_t rc;
-	sysarg_t rc_orig;
+	return rc;
+}
+
+/** Get file information 
+ *
+ * @param path          File path to get information about
+ * @param[out] stat     Place to store file information
+ *
+ * @return              EOK on success or a negative error code
+ */
+int vfs_stat_path(const char *path, struct stat *stat)
+{
+	int file = vfs_lookup(path, 0);
+	if (file < 0)
+		return file;
+	
+	int rc = vfs_stat(file, stat);
+
+	vfs_put(file);
+
+	return rc;
+}
+
+/** Get filesystem statistics
+ *
+ * @param file          File located on the queried file system
+ * @param[out] st       Buffer for storing information
+ *
+ * @return              EOK on success or a negative error code
+ */
+int vfs_statfs(int file, struct statfs *st)
+{
+	sysarg_t rc, ret;
 	aid_t req;
-	
-	size_t pa_size;
-	char *pa = vfs_absolutize(path, &pa_size);
-	if (pa == NULL) {
-		errno = ENOMEM;
-		return -1;
-	}
-	
-	async_exch_t *exch = vfs_exchange_begin();
-	
-	req = async_send_0(exch, VFS_IN_STAT, NULL);
-	rc = async_data_write_start(exch, pa, pa_size);
-	if (rc != EOK) {
-		vfs_exchange_end(exch);
-		free(pa);
-		async_wait_for(req, &rc_orig);
-		if (rc_orig != EOK)
-			rc = rc_orig;
-		if (rc != EOK) {
-			errno = rc;
-			return -1;
-		}
-	}
-	rc = async_data_read_start(exch, stat, sizeof(struct stat));
-	if (rc != EOK) {
-		vfs_exchange_end(exch);
-		free(pa);
-		async_wait_for(req, &rc_orig);
-		if (rc_orig != EOK)
-			rc = rc_orig;
-		if (rc != EOK) {
-			errno = rc;
-			return -1;
-		}
-	}
-	vfs_exchange_end(exch);
-	free(pa);
-	async_wait_for(req, &rc);
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-	return 0;
-}
-
-/** Open directory.
- *
- * @param dirname Directory pathname
- *
- * @return Non-NULL pointer on success. On error returns @c NULL and sets errno.
- */
-DIR *opendir(const char *dirname)
-{
-	DIR *dirp = malloc(sizeof(DIR));
-	int fd = -1;
-	
-	if (dirp == NULL) {
-		errno = ENOMEM;
-		return NULL;
-	}
-	
-	size_t abs_size;
-	char *abs = vfs_absolutize(dirname, &abs_size);
-	if (abs == NULL) {
-		free(dirp);
-		errno = ENOMEM;
-		return NULL;
-	}
-	
-	int rc = open_internal(abs, abs_size, L_DIRECTORY, 0, &fd);
-	free(abs);
-	
-	if (rc != EOK) {
-		free(dirp);
-		errno = rc;
-		return NULL;
-	}
-	
-	dirp->fd = fd;
-	return dirp;
-}
-
-/** Read directory entry.
- *
- * @param dirp Open directory
- * @return Non-NULL pointer to directory entry on success. On error returns
- *         @c NULL and sets errno.
- */
-struct dirent *readdir(DIR *dirp)
-{
-	int rc;
-	ssize_t len;
-	
-	rc = _read_short(dirp->fd, &dirp->res.d_name[0], NAME_MAX + 1, &len);
-	if (rc != EOK) {
-		errno = rc;
-		return NULL;
-	}
-	
-	(void) len;
-	return &dirp->res;
-}
-
-/** Rewind directory position to the beginning.
- *
- * @param dirp Open directory
- */
-void rewinddir(DIR *dirp)
-{
-	(void) lseek(dirp->fd, 0, SEEK_SET);
-}
-
-/** Close directory.
- *
- * @param dirp Open directory
- * @return 0 on success. On error returns -1 and sets errno.
- */
-int closedir(DIR *dirp)
-{
-	int rc;
-	
-	rc = close(dirp->fd);
-	free(dirp);
-
-	/* On error errno was set by close() */
-	return rc;
-}
-
-/** Create directory.
- *
- * @param path Path
- * @param mode File mode
- * @return 0 on success. On error returns -1 and sets errno.
- */
-int mkdir(const char *path, mode_t mode)
+
+	async_exch_t *exch = vfs_exchange_begin();
+
+	req = async_send_1(exch, VFS_IN_STATFS, file, NULL);
+	rc = async_data_read_start(exch, (void *) st, sizeof(*st));
+
+	vfs_exchange_end(exch);
+	async_wait_for(req, &ret);
+
+	rc = (ret != EOK ? ret : rc);
+
+	return rc;
+}
+
+/** Get filesystem statistics
+ *
+ * @param file          Path pointing to the queried file system
+ * @param[out] st       Buffer for storing information
+ *
+ * @return              EOK on success or a negative error code
+ */
+int vfs_statfs_path(const char *path, struct statfs *st)
+{
+	int file = vfs_lookup(path, 0);
+	if (file < 0)
+		return file;
+	
+	int rc = vfs_statfs(file, st);
+
+	vfs_put(file);
+
+	return rc; 
+}
+
+/** Synchronize file
+ *
+ * @param file  File handle to synchronize
+ *
+ * @return      EOK on success or a negative error code
+ */
+int vfs_sync(int file)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	int rc = async_req_1_0(exch, VFS_IN_SYNC, file);
+	vfs_exchange_end(exch);
+	
+	return rc;
+}
+
+/** Unlink a file or directory
+ *
+ * Unlink a name from a parent directory. The caller can supply the file handle
+ * of the unlinked child in order to detect a possible race with vfs_link() and
+ * avoid unlinking a wrong file. If the last link for a file or directory is
+ * removed, the FS implementation will deallocate its resources.
+ *
+ * @param parent        File handle of the parent directory node
+ * @param child         Old name to be unlinked
+ * @param expect        File handle of the unlinked child
+ *
+ * @return              EOK on success or a negative error code
+ */
+int vfs_unlink(int parent, const char *child, int expect)
 {
 	sysarg_t rc;
 	aid_t req;
 	
-	size_t pa_size;
-	char *pa = vfs_absolutize(path, &pa_size);
-	if (pa == NULL) {
-		errno = ENOMEM;
-		return -1;
-	}
-	
-	async_exch_t *exch = vfs_exchange_begin();
-	
-	req = async_send_1(exch, VFS_IN_MKDIR, mode, NULL);
-	rc = async_data_write_start(exch, pa, pa_size);
-	if (rc != EOK) {
-		vfs_exchange_end(exch);
-		free(pa);
+	async_exch_t *exch = vfs_exchange_begin();
+	
+	req = async_send_2(exch, VFS_IN_UNLINK, parent, expect, NULL);
+	rc = async_data_write_start(exch, child, str_size(child));
+	
+	vfs_exchange_end(exch);
+	
+	sysarg_t rc_orig;
+	async_wait_for(req, &rc_orig);
+	
+	if (rc_orig != EOK)
+		return (int) rc_orig;
+	return rc;
+}
+
+/** Unlink a file or directory
+ *
+ * Unlink a path. If the last link for a file or directory is removed, the FS
+ * implementation will deallocate its resources.
+ *
+ * @param path          Old path to be unlinked
+ *
+ * @return              EOK on success or a negative error code
+ */
+int vfs_unlink_path(const char *path)
+{
+	int expect = vfs_lookup(path, 0);
+	if (expect < 0)
+		return expect;
+
+	char *child;
+	int parent = get_parent_and_child(path, &child);
+	if (parent < 0) {
+		vfs_put(expect);
+		return parent;
+	}
+
+	int rc = vfs_unlink(parent, child, expect);
+	
+	free(child);
+	vfs_put(parent);
+	vfs_put(expect);
+	return rc;
+}
+
+/** Unmount a file system
+ *
+ * @param mp    File handle representing the mount-point
+ *
+ * @return      EOK on success or a negative error code
+ */
+int vfs_unmount(int mp)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	int rc = async_req_1_0(exch, VFS_IN_UNMOUNT, mp);
+	vfs_exchange_end(exch);
+	return rc;
+}
+
+/** Unmount a file system
+ *
+ * @param mpp   Mount-point path
+ *
+ * @return      EOK on success or a negative error code
+ */
+int vfs_unmount_path(const char *mpp)
+{
+	int mp = vfs_lookup(mpp, WALK_MOUNT_POINT | WALK_DIRECTORY);
+	if (mp < 0)
+		return mp;
+	
+	int rc = vfs_unmount(mp);
+	vfs_put(mp);
+	return rc;
+}
+
+/** Walk a path starting in a parent node
+ *
+ * @param parent        File handle of the parent node where the walk starts
+ * @param path          Parent-relative path to be walked
+ * @param flags         Flags influencing the walk
+ *
+ * @retrun              File handle representing the result on success or
+ *                      a negative error code on error
+ */
+int vfs_walk(int parent, const char *path, int flags)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	
+	ipc_call_t answer;
+	aid_t req = async_send_2(exch, VFS_IN_WALK, parent, flags, &answer);
+	sysarg_t rc = async_data_write_start(exch, path, str_size(path));
+	vfs_exchange_end(exch);
 		
-		sysarg_t rc_orig;
-		async_wait_for(req, &rc_orig);
+	sysarg_t rc_orig;
+	async_wait_for(req, &rc_orig);
+
+	if (rc_orig != EOK)
+		return (int) rc_orig;
 		
-		if (rc_orig != EOK)
-			rc = rc_orig;
-		
-		if (rc != EOK) {
-			errno = rc;
-			return -1;
-		}
-		
-		return 0;
-	}
-	
-	vfs_exchange_end(exch);
-	free(pa);
-	async_wait_for(req, &rc);
-	
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-	
-	return 0;
-}
-
-/** Unlink a file or directory.
- *
- * @param path Path to file or empty directory
- * @param lflag L_xxx flag (L_NONE, L_FILE or L_DIRECTORY)
- * @return EOK on success, non-zero error code on error
- */
-static int _unlink(const char *path, int lflag)
+	if (rc != EOK)
+		return (int) rc;
+	
+	return (int) IPC_GET_ARG1(answer);
+}
+
+/** Write data
+ *
+ * This function fails if it cannot write exactly @a len bytes to the file.
+ *
+ * @param file          File handle to write to
+ * @param[inout] pos    Position to write to, updated by the actual bytes
+ *                      written
+ * @param buf           Data, @a nbytes bytes long
+ * @param nbytes        Number of bytes to write
+ *
+ * @return		On success, non-negative number of bytes written
+ * @return              On failure, a negative error code
+ */
+ssize_t vfs_write(int file, aoff64_t *pos, const void *buf, size_t nbyte)
+{
+	ssize_t cnt = 0;
+	ssize_t nwritten = 0;
+	const uint8_t *bp = (uint8_t *) buf;
+	int rc;
+
+	do {
+		bp += cnt;
+		nwritten += cnt;
+		*pos += cnt;
+		rc = vfs_write_short(file, *pos, bp, nbyte - nwritten, &cnt);
+	} while (rc == EOK && ((ssize_t )nbyte - nwritten - cnt) > 0);
+
+	if (rc != EOK)
+		return rc;
+
+	*pos += cnt;
+	return nbyte;
+}
+
+/** Write bytes to a file
+ *
+ * Write up to @a nbyte bytes from file. The actual number of bytes written
+ * may be lower, but greater than zero.
+ *
+ * @param file          File handle to write to
+ * @param[in] pos       Position to write to
+ * @param buf           Buffer to write to
+ * @param nbyte         Maximum number of bytes to write
+ * @param[out] nread    Actual number of bytes written (0 or more)
+ *
+ * @return              EOK on success or a negative error code
+ */
+int vfs_write_short(int file, aoff64_t pos, const void *buf, size_t nbyte,
+    ssize_t *nwritten)
 {
 	sysarg_t rc;
+	ipc_call_t answer;
 	aid_t req;
 	
-	size_t pa_size;
-	char *pa = vfs_absolutize(path, &pa_size);
-	if (pa == NULL)
-		return ENOMEM;
-	
-	async_exch_t *exch = vfs_exchange_begin();
-	
-	req = async_send_1(exch, VFS_IN_UNLINK, lflag, NULL);
-	rc = async_data_write_start(exch, pa, pa_size);
-	if (rc != EOK) {
-		vfs_exchange_end(exch);
-		free(pa);
-
-		sysarg_t rc_orig;
-		async_wait_for(req, &rc_orig);
-
-		if (rc_orig == EOK)
-			return (int) rc;
-		else
-			return (int) rc_orig;
-	}
-	vfs_exchange_end(exch);
-	free(pa);
-	async_wait_for(req, &rc);
-	return rc;
-}
-
-/** Unlink file or directory.
- *
- * @param path Path
- * @return EOk on success, error code on error
- */
-int unlink(const char *path)
-{
-	int rc;
-
-	rc = _unlink(path, L_NONE);
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-
-	return 0;
-}
-
-/** Remove empty directory.
- *
- * @param path Path
- * @return 0 on success. On error returns -1 and sets errno.
- */
-int rmdir(const char *path)
-{
-	int rc;
-
-	rc = _unlink(path, L_DIRECTORY);
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-
-	return 0;
-}
-
-/** Rename directory entry.
- *
- * @param old Old name
- * @param new New name
- *
- * @return 0 on success. On error returns -1 and sets errno.
- */
-int rename(const char *old, const char *new)
-{
-	sysarg_t rc;
-	sysarg_t rc_orig;
-	aid_t req;
-	
-	size_t olda_size;
-	char *olda = vfs_absolutize(old, &olda_size);
-	if (olda == NULL) {
-		errno = ENOMEM;
-		return -1;
-	}
-
-	size_t newa_size;
-	char *newa = vfs_absolutize(new, &newa_size);
-	if (newa == NULL) {
-		free(olda);
-		errno = ENOMEM;
-		return -1;
-	}
-	
-	async_exch_t *exch = vfs_exchange_begin();
-	
-	req = async_send_0(exch, VFS_IN_RENAME, NULL);
-	rc = async_data_write_start(exch, olda, olda_size);
-	if (rc != EOK) {
-		vfs_exchange_end(exch);
-		free(olda);
-		free(newa);
-		async_wait_for(req, &rc_orig);
-		if (rc_orig != EOK)
-			rc = rc_orig;
-		if (rc != EOK) {
-			errno = rc;
-			return -1;
-		}
-		return 0;
-	}
-	rc = async_data_write_start(exch, newa, newa_size);
-	if (rc != EOK) {
-		vfs_exchange_end(exch);
-		free(olda);
-		free(newa);
-		async_wait_for(req, &rc_orig);
-		if (rc_orig != EOK)
-			rc = rc_orig;
-		if (rc != EOK) {
-			errno = rc;
-			return -1;
-		}
-		return 0;
-	}
-	vfs_exchange_end(exch);
-	free(olda);
-	free(newa);
-	async_wait_for(req, &rc);
-
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-
-	return 0;
-}
-
-/** Remove directory entry.
- *
- * @param path Path
- * @return 0 on success. On error returns -1 and sets errno.
- */
-int remove(const char *path)
-{
-	return unlink(path);
-}
-
-/** Change working directory.
- *
- * @param path Path
- * @return 0 on success. On error returns -1 and sets errno.
- */
-int chdir(const char *path)
-{
-	size_t abs_size;
-	char *abs = vfs_absolutize(path, &abs_size);
-	int fd = -1;
-	
-	if (abs == NULL) {
-		errno = ENOMEM;
-		return -1;
-	}
-	
-	int rc = open_internal(abs, abs_size, L_DIRECTORY, O_DESC, &fd);
-	
-	if (rc != EOK) {
-		free(abs);
-		errno = rc;
-		return -1;
-	}
-	
-	fibril_mutex_lock(&cwd_mutex);
-	
-	if (cwd_fd >= 0)
-		close(cwd_fd);
-	
-	if (cwd_path)
-		free(cwd_path);
-	
-	cwd_fd = fd;
-	cwd_path = abs;
-	cwd_size = abs_size;
-	
-	fibril_mutex_unlock(&cwd_mutex);
-	return 0;
-}
-
-/** Get current working directory path.
- *
- * @param buf Buffer
- * @param size Size of @a buf
- * @return On success returns @a buf. On failure returns @c NULL and sets errno.
- */
-char *getcwd(char *buf, size_t size)
-{
-	if (size == 0) {
-		errno = EINVAL;
-		return NULL;
-	}
-	
-	fibril_mutex_lock(&cwd_mutex);
-	
-	if ((cwd_size == 0) || (size < cwd_size + 1)) {
-		fibril_mutex_unlock(&cwd_mutex);
-		errno = ERANGE;
-		return NULL;
-	}
-	
-	str_cpy(buf, size, cwd_path);
-	fibril_mutex_unlock(&cwd_mutex);
-	
-	return buf;
-}
-
-/** Open session to service represented by a special file.
- *
- * Given that the file referred to by @a fildes represents a service,
- * open a session to that service.
- *
- * @param fildes File descriptor
- * @param iface Interface to connect to (XXX Should be automatic)
- * @return On success returns session pointer. On error returns @c NULL.
- */
-async_sess_t *vfs_fd_session(int fildes, iface_t iface)
-{
-	struct stat stat;
-	int rc = fstat(fildes, &stat);
-	if (rc != 0)
-		return NULL;
-	
-	if (stat.service == 0)
-		return NULL;
-	
-	return loc_service_connect(stat.service, iface, 0);
-}
-
-/** Duplicate open file.
- *
- * Duplicate open file under a new file descriptor.
- *
- * @param oldfd Old file descriptor
- * @param newfd New file descriptor
- * @return 0 on success. On error -1 is returned and errno is set
- */
-int dup2(int oldfd, int newfd)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	
-	sysarg_t ret;
-	sysarg_t rc = async_req_2_1(exch, VFS_IN_DUP, oldfd, newfd, &ret);
+	if (nbyte > DATA_XFER_LIMIT)
+		nbyte = DATA_XFER_LIMIT;
+	
+	async_exch_t *exch = vfs_exchange_begin();
+	
+	req = async_send_3(exch, VFS_IN_WRITE, file, LOWER32(pos),
+	    UPPER32(pos), &answer);
+	rc = async_data_write_start(exch, (void *) buf, nbyte);
 	
 	vfs_exchange_end(exch);
 	
 	if (rc == EOK)
-		rc = ret;
-	
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-	
-	return 0;
-}
-
-int vfs_fd_wait(void)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	
-	sysarg_t ret;
-	sysarg_t rc = async_req_0_1(exch, VFS_IN_WAIT_HANDLE, &ret);
-	
-	vfs_exchange_end(exch);
-	
-	if (rc == EOK)
-		return (int) ret;
-	
-	return (int) rc;
-}
-
-int vfs_get_mtab_list(list_t *mtab_list)
-{
-	sysarg_t rc;
-	aid_t req;
-	size_t i;
-	sysarg_t num_mounted_fs;
-	
-	async_exch_t *exch = vfs_exchange_begin();
-
-	req = async_send_0(exch, VFS_IN_MTAB_GET, NULL);
-
-	/* Ask VFS how many filesystems are mounted */
-	rc = async_req_0_1(exch, VFS_IN_PING, &num_mounted_fs);
+		async_wait_for(req, &rc);
+	else
+		async_forget(req);
+
 	if (rc != EOK)
-		goto exit;
-
-	for (i = 0; i < num_mounted_fs; ++i) {
-		mtab_ent_t *mtab_ent;
-
-		mtab_ent = malloc(sizeof(mtab_ent_t));
-		if (mtab_ent == NULL) {
-			rc = ENOMEM;
-			goto exit;
-		}
-
-		memset(mtab_ent, 0, sizeof(mtab_ent_t));
-
-		rc = async_data_read_start(exch, (void *) mtab_ent->mp,
-		    MAX_PATH_LEN);
-		if (rc != EOK)
-			goto exit;
-
-		rc = async_data_read_start(exch, (void *) mtab_ent->opts,
-			MAX_MNTOPTS_LEN);
-		if (rc != EOK)
-			goto exit;
-
-		rc = async_data_read_start(exch, (void *) mtab_ent->fs_name,
-			FS_NAME_MAXLEN);
-		if (rc != EOK)
-			goto exit;
-
-		sysarg_t p[2];
-
-		rc = async_req_0_2(exch, VFS_IN_PING, &p[0], &p[1]);
-		if (rc != EOK)
-			goto exit;
-
-		mtab_ent->instance = p[0];
-		mtab_ent->service_id = p[1];
-
-		link_initialize(&mtab_ent->link);
-		list_append(&mtab_ent->link, mtab_list);
-	}
-
-exit:
-	async_wait_for(req, &rc);
-	vfs_exchange_end(exch);
-	return rc;
-}
-
-/** Get filesystem statistics.
- *
- * @param path Mount point path
- * @param st Buffer for storing information
- * @return 0 on success. On error -1 is returned and errno is set.
- */
-int statfs(const char *path, struct statfs *st)
-{
-	sysarg_t rc, rc_orig;
-	aid_t req;
-	size_t pa_size;
-
-	char *pa = vfs_absolutize(path, &pa_size);
-	if (pa == NULL) {
-		errno = ENOMEM;
-		return -1;
-	}
-
-	async_exch_t *exch = vfs_exchange_begin();
-
-	req = async_send_0(exch, VFS_IN_STATFS, NULL);
-	rc = async_data_write_start(exch, pa, pa_size);
-	if (rc != EOK)
-		goto exit;
-
-	rc = async_data_read_start(exch, (void *) st, sizeof(*st));
-
-exit:
-	vfs_exchange_end(exch);
-	free(pa);
-	async_wait_for(req, &rc_orig);
-	rc = (rc_orig != EOK ? rc_orig : rc);
-
-	if (rc != EOK) {
-		errno = rc;
-		return -1;
-	}
-
-	return 0;
+		return rc;
+	
+	*nwritten = (ssize_t) IPC_GET_ARG1(answer);
+	return EOK;
 }
 
Index: uspace/lib/c/include/dirent.h
===================================================================
--- uspace/lib/c/include/dirent.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/dirent.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -38,4 +38,6 @@
 #define NAME_MAX  256
 
+#include <sys/types.h>
+
 struct dirent {
 	char d_name[NAME_MAX + 1];
@@ -45,4 +47,5 @@
 	int fd;
 	struct dirent res;
+	aoff64_t pos;
 } DIR;
 
Index: uspace/lib/c/include/elf/elf_load.h
===================================================================
--- uspace/lib/c/include/elf/elf_load.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/elf/elf_load.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -45,5 +45,5 @@
 } elf_info_t;
 
-extern int elf_load(const char *, elf_info_t *);
+extern int elf_load(int, elf_info_t *);
 extern void elf_set_pcb(elf_info_t *, pcb_t *);
 
Index: uspace/lib/c/include/elf/elf_mod.h
===================================================================
--- uspace/lib/c/include/elf/elf_mod.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/elf/elf_mod.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -108,5 +108,6 @@
 
 extern const char *elf_error(unsigned int);
-extern int elf_load_file(const char *, size_t, eld_flags_t, elf_finfo_t *);
+extern int elf_load_file(int, size_t, eld_flags_t, elf_finfo_t *);
+extern int elf_load_file_name(const char *, size_t, eld_flags_t, elf_finfo_t *);
 
 #endif
Index: uspace/lib/c/include/io/logctl.h
===================================================================
--- uspace/lib/c/include/io/logctl.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/io/logctl.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -38,4 +38,5 @@
 extern int logctl_set_default_level(log_level_t);
 extern int logctl_set_log_level(const char *, log_level_t);
+extern int logctl_set_root(void);
 
 #endif
Index: uspace/lib/c/include/ipc/loader.h
===================================================================
--- uspace/lib/c/include/ipc/loader.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/ipc/loader.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -42,7 +42,7 @@
 	LOADER_GET_TASKID,
 	LOADER_SET_CWD,
-	LOADER_SET_PATHNAME,
+	LOADER_SET_PROGRAM,
 	LOADER_SET_ARGS,
-	LOADER_SET_FILES,
+	LOADER_ADD_INBOX,
 	LOADER_LOAD,
 	LOADER_RUN
Index: uspace/lib/c/include/ipc/logger.h
===================================================================
--- uspace/lib/c/include/ipc/logger.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/ipc/logger.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -49,5 +49,11 @@
 	 * Followed by: string with full log name.
 	 */
-	LOGGER_CONTROL_SET_LOG_LEVEL
+	LOGGER_CONTROL_SET_LOG_LEVEL,
+	/** Set VFS root.
+	 *
+	 * Returns: error code
+	 * Followed by: vfs_pass_handle() request.
+	 */ 
+	LOGGER_CONTROL_SET_ROOT
 } logger_control_request_t;
 
Index: uspace/lib/c/include/ipc/vfs.h
===================================================================
--- uspace/lib/c/include/ipc/vfs.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/ipc/vfs.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,5 +41,5 @@
 
 #define FS_NAME_MAXLEN  20
-#define MAX_PATH_LEN    (64 * 1024)
+#define MAX_PATH_LEN    (32 * 1024)
 #define MAX_MNTOPTS_LEN 256
 #define PLB_SIZE        (2 * MAX_PATH_LEN)
@@ -63,41 +63,37 @@
 
 typedef enum {
-	VFS_IN_OPEN = IPC_FIRST_USER_METHOD,
+	VFS_IN_CLONE = IPC_FIRST_USER_METHOD,
+	VFS_IN_MOUNT,
+	VFS_IN_OPEN,
+	VFS_IN_PUT,
 	VFS_IN_READ,
+	VFS_IN_REGISTER,
+	VFS_IN_RENAME,
+	VFS_IN_RESIZE,
+	VFS_IN_STAT,
+	VFS_IN_STATFS,
+	VFS_IN_SYNC,
+	VFS_IN_UNLINK,
+	VFS_IN_UNMOUNT,
+	VFS_IN_WAIT_HANDLE,
+	VFS_IN_WALK,
 	VFS_IN_WRITE,
-	VFS_IN_SEEK,
-	VFS_IN_TRUNCATE,
-	VFS_IN_FSTAT,
-	VFS_IN_CLOSE,
-	VFS_IN_PING,
-	VFS_IN_MOUNT,
-	VFS_IN_UNMOUNT,
-	VFS_IN_SYNC,
-	VFS_IN_REGISTER,
-	VFS_IN_MKDIR,
-	VFS_IN_UNLINK,
-	VFS_IN_RENAME,
-	VFS_IN_STAT,
-	VFS_IN_DUP,
-	VFS_IN_WAIT_HANDLE,
-	VFS_IN_MTAB_GET,
-	VFS_IN_STATFS
 } vfs_in_request_t;
 
 typedef enum {
-	VFS_OUT_OPEN_NODE = IPC_FIRST_USER_METHOD,
+	VFS_OUT_CLOSE = IPC_FIRST_USER_METHOD,
+	VFS_OUT_DESTROY,
+	VFS_OUT_IS_EMPTY,
+	VFS_OUT_LINK,
+	VFS_OUT_LOOKUP,
+	VFS_OUT_MOUNTED,
+	VFS_OUT_OPEN_NODE,
 	VFS_OUT_READ,
+	VFS_OUT_STAT,
+	VFS_OUT_STATFS,
+	VFS_OUT_SYNC,
+	VFS_OUT_TRUNCATE,
+	VFS_OUT_UNMOUNTED,
 	VFS_OUT_WRITE,
-	VFS_OUT_TRUNCATE,
-	VFS_OUT_CLOSE,
-	VFS_OUT_MOUNT,
-	VFS_OUT_MOUNTED,
-	VFS_OUT_UNMOUNT,
-	VFS_OUT_UNMOUNTED,
-	VFS_OUT_SYNC,
-	VFS_OUT_STAT,
-	VFS_OUT_LOOKUP,
-	VFS_OUT_DESTROY,
-	VFS_OUT_STATFS,
 	VFS_OUT_LAST
 } vfs_out_request_t;
@@ -127,12 +123,12 @@
 
 /**
- * Lookup will succeed only if the object is a root directory. The flag is
- * mutually exclusive with L_FILE and L_MP.
+ * Lookup will not cross any mount points.
+ * If the lookup would have to cross a mount point, it returns EXDEV instead.
  */
-#define L_ROOT			4
+#define L_DISABLE_MOUNTS	4
 
 /**
  * Lookup will succeed only if the object is a mount point. The flag is mutually
- * exclusive with L_FILE and L_ROOT.
+ * exclusive with L_FILE.
  */
 #define L_MP			8
@@ -151,22 +147,36 @@
 
 /**
- * L_LINK is used for linking to an already existing nodes.
- */
-#define L_LINK			64
-
-/**
  * L_UNLINK is used to remove leaves from the file system namespace. This flag
  * cannot be passed directly by the client, but will be set by VFS during
  * VFS_UNLINK.
  */
-#define L_UNLINK		128
+#define L_UNLINK		64
 
-/**
- * L_OPEN is used to indicate that the lookup operation is a part of VFS_IN_OPEN
- * call from the client. This means that the server might allocate some
- * resources for the opened file. This flag cannot be passed directly by the
- * client.
+/*
+ * Walk flags.
  */
-#define L_OPEN			256
+enum {
+	WALK_MAY_CREATE = (1 << 0),
+	WALK_MUST_CREATE = (1 << 1),
+	
+	WALK_REGULAR = (1 << 2),
+	WALK_DIRECTORY = (1 << 3),
+	WALK_MOUNT_POINT = (1 << 4),
+	
+	WALK_ALL_FLAGS = WALK_MAY_CREATE | WALK_MUST_CREATE | WALK_REGULAR |
+	    WALK_DIRECTORY | WALK_MOUNT_POINT,
+};
+
+enum {
+	VFS_MOUNT_BLOCKING = 1,
+	VFS_MOUNT_CONNECT_ONLY = 2,
+	VFS_MOUNT_NO_REF = 4,
+};
+
+enum {
+	MODE_READ = 1,
+	MODE_WRITE = 2,
+	MODE_APPEND = 4,
+};
 
 #endif
Index: uspace/lib/c/include/loader/loader.h
===================================================================
--- uspace/lib/c/include/loader/loader.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/loader/loader.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -47,7 +47,8 @@
 extern int loader_get_task_id(loader_t *, task_id_t *);
 extern int loader_set_cwd(loader_t *);
-extern int loader_set_pathname(loader_t *, const char *);
+extern int loader_set_program(loader_t *, const char *, int);
+extern int loader_set_program_path(loader_t *, const char *);
 extern int loader_set_args(loader_t *, const char *const[]);
-extern int loader_set_files(loader_t *, int *const[]);
+extern int loader_add_inbox(loader_t *, const char *, int);
 extern int loader_load_program(loader_t *);
 extern int loader_run(loader_t *);
Index: uspace/lib/c/include/loader/pcb.h
===================================================================
--- uspace/lib/c/include/loader/pcb.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/loader/pcb.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,4 +41,9 @@
 typedef void (*entry_point_t)(void);
 
+struct pcb_inbox_entry {
+	char *name;
+	int file;
+};
+
 /** Program Control Block.
  *
@@ -60,6 +65,7 @@
 	char **argv;
 	
-	/** Number of preset files. */
-	unsigned int filc;
+	/** List of inbox files. */
+	struct pcb_inbox_entry *inbox;
+	int inbox_entries;
 	
 	/*
Index: uspace/lib/c/include/stdio.h
===================================================================
--- uspace/lib/c/include/stdio.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/stdio.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -44,15 +44,4 @@
 #define EOF  (-1)
 
-/** Default size for stream I/O buffers */
-#define BUFSIZ  4096
-
-#define DEBUG(fmt, ...) \
-	{ \
-		char _buf[256]; \
-		int _n = snprintf(_buf, sizeof(_buf), fmt, ##__VA_ARGS__); \
-		if (_n > 0) \
-			(void) __SYSCALL3(SYS_KIO, KIO_WRITE, (sysarg_t) _buf, str_size(_buf)); \
-	}
-
 #ifndef SEEK_SET
 	#define SEEK_SET  0
@@ -66,4 +55,15 @@
 	#define SEEK_END  2
 #endif
+
+/** Default size for stream I/O buffers */
+#define BUFSIZ  4096
+
+#define DEBUG(fmt, ...) \
+	{ \
+		char _buf[256]; \
+		int _n = snprintf(_buf, sizeof(_buf), fmt, ##__VA_ARGS__); \
+		if (_n > 0) \
+			(void) __SYSCALL3(SYS_KIO, KIO_WRITE, (sysarg_t) _buf, str_size(_buf)); \
+	}
 
 enum _buffer_type {
@@ -153,8 +153,4 @@
 extern void setbuf(FILE *, void *);
 
-/* Misc file functions */
-extern int rename(const char *, const char *);
-extern int remove(const char *);
-
 #endif
 
Index: uspace/lib/c/include/stdlib.h
===================================================================
--- uspace/lib/c/include/stdlib.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/stdlib.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -49,4 +49,5 @@
 
 extern void abort(void) __attribute__((noreturn));
+extern void exit(int) __attribute__((noreturn));
 
 #endif
Index: uspace/lib/c/include/sys/types.h
===================================================================
--- uspace/lib/c/include/sys/types.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/sys/types.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -38,6 +38,4 @@
 #include <libarch/types.h>
 
-typedef unsigned int mode_t;
-
 /** Relative offset */
 typedef int64_t off64_t;
Index: uspace/lib/c/include/task.h
===================================================================
--- uspace/lib/c/include/task.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/task.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -57,5 +57,5 @@
     const char *const []);
 extern int task_spawnvf(task_id_t *, task_wait_t *, const char *path,
-    const char *const [], int *const []);
+    const char *const [], int, int, int);
 extern int task_spawn(task_id_t *, task_wait_t *, const char *path, int,
     va_list ap);
Index: uspace/lib/c/include/unistd.h
===================================================================
--- uspace/lib/c/include/unistd.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/c/include/unistd.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -44,35 +44,6 @@
 #endif
 
-#ifndef SEEK_SET
-	#define SEEK_SET  0
-#endif
-
-#ifndef SEEK_CUR
-	#define SEEK_CUR  1
-#endif
-
-#ifndef SEEK_END
-	#define SEEK_END  2
-#endif
-
 #define getpagesize()  (PAGE_SIZE)
 
-extern int dup2(int, int);
-
-extern ssize_t write(int, const void *, size_t);
-extern ssize_t read(int, void *, size_t);
-
-extern off64_t lseek(int, off64_t, int);
-extern int ftruncate(int, aoff64_t);
-
-extern int close(int);
-extern int fsync(int);
-extern int unlink(const char *);
-
-extern char *getcwd(char *, size_t);
-extern int rmdir(const char *);
-extern int chdir(const char *);
-
-extern void exit(int) __attribute__((noreturn));
 extern int usleep(useconds_t);
 extern unsigned int sleep(unsigned int);
Index: uspace/lib/c/include/vfs/inbox.h
===================================================================
--- uspace/lib/c/include/vfs/inbox.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
+++ uspace/lib/c/include/vfs/inbox.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2013 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc 
+ * @{
+ */ 
+
+/**
+ * @file
+ * @brief
+ */
+
+#ifndef LIBC_VFS_INBOX_H_
+#define LIBC_VFS_INBOX_H_
+
+enum {
+	INBOX_MAX_ENTRIES = 256,
+};
+
+extern int inbox_set(const char *name, int file);
+extern int inbox_get(const char *name);
+
+extern int inbox_list(const char **names, int capacity);
+
+#endif
+
+/**
+ * @}
+ */
